unit FormAanestys;
(*
   nestyspohja.

   Muokattu: 4.8.2004 / Miika Nurminen
    - listty dde-komponenttien generointi taulukossa
*)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Series, DdeMan;

type
  TFormAanestyspohja = class(TForm)
    RadioGroupAanestys: TRadioGroup;
    ButtonAanesta: TButton;
    LabelAanet: TLabel;
    AanetLkm: TDdeServerConv;
    procedure ButtonAanestaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    //kylla, ei, eos: integer;
    aanet : array of integer;
    ddeaanet : array of TDdeServerItem;
    Flkm : integer;
    procedure paivita();
  public
    property lkm:integer read Flkm;
  end;

var
  FormAanestyspohja: TFormAanestyspohja;
//  kylla, ei, eos: integer;  // VL: EI IKIN Globaaleja muuttujia


implementation

{$R *.dfm}


// MN: DDE-komponenttien nimet moduulin sisisin vakioina
//  huom. nm voitaisiin generoida mys dynaamisesti, tyyliin
//  item1, item2...
var strlabels : array [0..4] of String = (
 'kylla','ei','eos','jaa','ehka'
);


procedure TFormAanestyspohja.ButtonAanestaClick(Sender: TObject);
(*
  procedure aanesta(var aanet: Integer);   // void aanesta(int *aanet)
  begin
    aanet := aanet + 1;
    // aanet^ := aanet^ + 1;
    // *aanet = *aanet + 1;  // *aanet += 1;  // (*aanet)++;
  end;
*)
  var kysymys : string;i:integer;
begin
  if (RadioGroupAanestys.ItemIndex = -1) then exit;

  Inc(aanet[RadioGroupAanestys.ItemIndex]);

  paivita;
end;

procedure TFormAanestyspohja.paivita();
var s: String; i:Integer;
begin
  s := '';

  // MN: pivitetn samaan aikaan label ja ddeitemit
  for i:=0 to lkm-1 do begin
    s := s + RadioGroupAanestys.Items[i] + ': ' + IntToStr(aanet[i]);
    ddeaanet[i].Text := IntToStr(aanet[i]);
  end;
  LabelAanet.Caption := s;

end;

var varit : array[0..3] of TColor = (clGreen,clRed,clYellow,clBlue);

function annavari(i:integer):TColor;
begin
  Result := varit[i mod Length(varit)];
end;

procedure TFormAanestyspohja.FormCreate(Sender: TObject);
var i : integer;
begin
//  kylla := 0;
//  ei := 0;
//  eos := 0;
  Flkm := RadioGroupAanestys.Items.Count;

  SetLength(aanet,lkm);
  for i:=0 to lkm-1 do begin
    aanet[i] := 0;
  end;

  // MN: luodaan dynaamisesti ddeitemit
  SetLength(ddeaanet,lkm);
  for i:=0 to lkm-1 do begin
    // MN: omistaja on lomake, joten se vastaa tuhoamisesta
    ddeaanet[i] := TDdeServerItem.Create(self);
    ddeaanet[i].Name := strlabels[i];
    ddeaanet[i].ServerConv := AanetLkm;
  end;

end;

procedure TFormAanestyspohja.FormDestroy(Sender: TObject);
begin
 // MN: vapautetaan dynaamiset taulukot
  aanet := nil;
  ddeaanet := nil;
end;

end.
